#pragma once

#include <vector>
#include <set>
#include <stack>

#include "../Core/Core.h"

namespace rm {
namespace resource {

// 从文件读取地图
grid_t<bool> get_map(const char* filename);

// 从文件读取计划的所有目的地
std::stack<std::pair<Node, uint32_t>> get_all_dst(const char* filename);

// 从文件读取旋转门旋转区域
std::set<Node> get_revolve_area(const char* filename);

// 从文件读取车子速度
Vehicle get_vehicle(const char* filename);

} // namespace
} // namespace
