#pragma once

#include <string>

#include "../Core/Core.h"
#include "Source/serial_device.h"

// Wrapper

namespace rm {

struct SendData {
    Node next_node; // 4 + 4 bits
    uint32_t direction; // 2 bits
    bool is_at_dst; // 1 bit;
    SendData& operator=(const SendData& rhs);
};

struct ReceiveData {
    Node curr_node; // 4 + 4 bits
    bool front_unavailable; // 1 bit
    bool found_enemy_cube; // 1 bit
    bool got_a_cube; // 1 bit
    bool go_to_end_node; // 1 bit
    ReceiveData& operator=(const ReceiveData& rhs);
};

struct Serial {
    roborts_sdk::SerialDevice _serial;
    Serial(std::string port_name, int baudrate);
    void _read(uint8_t* buf, int len);
    void send(const SendData& send_data);
    ReceiveData receive();
};

} // namespace
